//
// Created by robin on 1/14/18.
//

#ifndef QDNSAGG_QDNSRECORDDATARAW_H
#define QDNSAGG_QDNSRECORDDATARAW_H

#include "QDnsRecordData.h"

namespace QDns
{
    namespace Base
    {
        class QDnsRecordDataRaw : public QDnsRecordData
        {
        public:
            QDnsRecordDataRaw();

            QDnsRecordDataRaw(const QByteArray &packetData, quint32 pos);

            QDnsRecordDataRaw(const QByteArray &packetData, QDataStream &dataStream);

            QByteArray serialize() const override;

            void serialize(QDataStream &dataStream) const override;

            virtual QDnsRecordData* clone() const override;

            const QByteArray &getData() const;

            void setData(const QByteArray &data);

            QString toString() const override;

        private:
            void parse(const QByteArray &packetData, QDataStream &dataStream);

            QByteArray m_data;
        };
    }
}

#endif //QDNSAGG_QDNSRECORDDATARAW_H
