//
// Created by robin on 1/31/18.
//

#ifndef QDNSAGG_QTCPDNSSERVER_H
#define QDNSAGG_QTCPDNSSERVER_H

#include <QTcpServer>
#include "QDnsServer.h"

namespace QDns
{
    namespace Server
    {
        class QDnsTcpServerClient;

        class QDnsTcpServer : public QDnsServer
        {
            Q_OBJECT
        public:
            explicit QDnsTcpServer(QObject* parent = nullptr);

        public slots:
            bool start(const QHostAddress& host, quint16 port) override;

        private slots:
            void onNewConnection();

        private:
            QTcpServer* m_socket;

            QList<QDnsTcpServerClient*> m_clients;
        };
    }
}

#endif //QDNSAGG_QTCPDNSSERVER_H
